(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("AxiosMiddleware", [], factory);
	else if(typeof exports === 'object')
		exports["AxiosMiddleware"] = factory();
	else
		root["AxiosMiddleware"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });

// CONCATENATED MODULE: ./src/middleware.js
/* eslint-disable class-methods-use-this, no-unused-vars */

/**
 * Default middleware implementation. Extend this class to create a custom middleware.
 */
class HttpMiddleware {
    /**
     * Default implementation is the identity function.
     * @param {Object} config
     * @returns {Object}
     */
    onRequest(config) {
        return config;
    }

    /**
     * Default implementation is a noop.
     * @param error
     */
    handleRequestError(error) { }

    /**
     * Default implementation is the identity function.
     * @param {Object} response
     * @returns {Object}
     */
    onResponse(response) {
        return response;
    }

    /**
     * Default implementation is a noop.
     * @param error
     */
    handleResponseError(error) { }
}

// CONCATENATED MODULE: ./src/service.js
class HttpMiddlewareService {
    constructor(axios) {
        this.middlewares = [];

        this.setHttp(axios);
    }

    /**
     *
     * @param {Axios} axios
     */
    setHttp(axios) {
        this.unsetHttp();

        this.http = axios;

        const interceptors = axios.interceptors;

        this._requestInterceptor = interceptors.request.use(
            config => this._onRequest(config),
            error => this._handleRequestError(error),
        );
        this._responseInterceptor = interceptors.response.use(
            response => this._onResponse(response),
            error => this._handleResponseError(error),
        );
        return this;
    }

    unsetHttp() {
        const http = this.http;
        if (this.http) {
            const interceptors = http.interceptors;
            interceptors.request.eject(this._requestInterceptor);
            interceptors.response.eject(this._responseInterceptor);
        }
    }

    /**
     * @param {HttpMiddleware} middleware
     * @returns {boolean} true if the middleware is already registered.
     */
    has(middleware) {
        return this.middlewares.indexOf(middleware) > -1;
    }

    /**
     * Add a middleware or an array of middlewares to the stack.
     * @param {HttpMiddleware|Array} middlewares
     */
    register(middlewares) {
        // eslint-disable-next-line no-param-reassign
        if (!Array.isArray(middlewares)) middlewares = [middlewares];

        // Test if middlewares are registered more than once.
        middlewares.forEach((middleware) => {
            if (this.has(middleware)) {
                throw new Error('Middleware already registered');
            }
            this.middlewares.push(middleware);
        });
    }

    /**
     * Remove a middleware from the registered stack.
     * @param {HttpMiddleware} middleware
     */
    unregister(middleware) {
        const index = this.middlewares.indexOf(middleware);
        if (index > -1) {
            this.middlewares.splice(index, 1);
        }
    }

    reset() {
        this.middlewares.length = 0;
    }

    _onRequest(config) {
        return this.middlewares.reduce(
            (acc, middleware) => middleware.onRequest(acc),
            config);
    }

    _handleRequestError(error) {
        this.middlewares.forEach(middleware => middleware.handleRequestError(error));
        return Promise.reject(error);
    }

    _onResponse(response) {
        return this.middlewares.reduce(
            (acc, middleware) => middleware.onResponse(acc),
            response);
    }

    _handleResponseError(error) {
        this.middlewares.forEach(middleware => middleware.handleResponseError(error));
        return Promise.reject(error);
    }
}

// CONCATENATED MODULE: ./src/index.js



/* harmony default export */ var src = __webpack_exports__["default"] = ({
    HttpMiddleware: HttpMiddleware,
    HttpMiddlewareService: HttpMiddlewareService,
});


/***/ })
/******/ ])["default"];
});